//+------------------------------------------------------------------+
//|                                                       proga1.mq4 |
//|                                                           |
//|                                      http//dimarik0000@yandex.ru |
//+------------------------------------------------------------------+
#property copyright ""
#property link      "http//dimarik0000@yandex.ru"



extern double StopLoss=50;
extern double TakeProfit=100;
extern double TrailingStop=20;
extern double Lots=0.2;
extern double MACDOpenLevel=1;
extern double MACDClosLevel=1;

extern double MA1=21;
extern double MA2=8;
extern double distance=5; //  1  2
extern double MA=200; //   

extern double total=1; //    
extern double MACD_fast_ema_period=12, MACD_slow_ema_period=26, MACD_signal_period=9;

extern int megic=777; //   .      
extern string symb; //  

bool signal; //     
//+------------------------------------------------------------------+
int start()
  { 
   RefreshRates();
   double MACD1, MACD2; // 1 ,
   int cnt;
   int ticket; 
   int type=0;
   string symb;
   
   //  
   symb=Symbol(); //   
   total=0; //  
   for(int i=1; i<=OrdersTotal(); i++) //   
    {
     if(OrderSelect(i-1,SELECT_BY_POS) && OrderType()>1 && OrderMagicNumber()==megic && OrderSymbol()==symb)
      {
       Alert("  ,    ");
       return;
      }
     total++;
     if(total>1) //    
      {
       Alert("  ,    ");
       return;
      }
     return; 
    }
   //  
   MA1=iMA(NULL,0,21,0,MODE_EMA,PRICE_CLOSE,0);
   MA2=iMA(NULL,0,8,0,MODE_EMA,PRICE_CLOSE,0);
   MA=iMA(NULL,0,200,0,MODE_EMA,PRICE_CLOSE,0);
   
   MACD1=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
   MACD2=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1);
   
   if(signal==OP_BUY && Bid>MA*Point)
   if(signal==OP_SELL && Bid<MA*Point)
   
   total=OrdersTotal();
    {
     if (total<1)
      {
       if (MA>MA1 && MA>MA2)
        {
         //    Sell
         if (MACD1<0 && MACD2<MACD1 && MACDOpenLevel*Point && MA1>MA2*Point)
          {
           OrderSend(Symbol(),OP_SELL,Lots,Bid,3,NormalizeDouble(Ask+200*Point,Digits),
           NormalizeDouble(Bid-1000*Point,Digits), " ",megic,0,0);
           if(ticket<=0)
            {
             int error=GetLastError();
             if(error==134) // 
             Sleep(5000); //  
             RefreshRates(); //  
            }
           else 
            {
             if(ticket>0)
              {
               if(OrderSelect(ticket,SELECT_BY_POS,MODE_TRADES)) Print(" : ", OrderOpenPrice());
                {
                 Print(GetLastError());
                 return;
                }
              }
            }
          }
        }
       return;
      }
     if (total<1)
      {
       if (MA<MA1 && MA<MA2)
        {
         //    Buy
         if (MACD1>0 && MACD2>MACD1 && MACDOpenLevel*Point && MA1<MA2*Point)
          {
           OrderSend(Symbol(),OP_SELL,Lots,Ask,3,NormalizeDouble(Bid-200*Point,Digits),
           NormalizeDouble(Ask+1000*Point,Digits), " ",megic,0,0);
           if(ticket<=0)
            {
             error=GetLastError();
             if(error==134) // 
             Sleep(5000); //  
             RefreshRates(); //  
            }
           else 
            {
             if(ticket>0)
            {
             if(OrderSelect(ticket,SELECT_BY_POS,MODE_TRADES)) Print(" ", OrderOpenPrice());
             Print("    #",GetLastError());
             return;
            }
          }
        }
      }
      return;
     }
    return;
    }
     //   Sell
     if(total>1)
      {
       for(cnt=0;cnt<total;cnt++)
        {
         OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==megic)
          {
           if(OrderType()==OP_SELL)
            {
             if(MACD1>0 && MACD2>MACD1 && MACDClosLevel*Point && MA1<MA2*Point)
              {
               OrderClose(OrderTicket(),0.2,Ask,3,0); //  
               return;
              }
            }
          }
        }
      }
     //   Buy
     if(total>1)
      {
       for(cnt=0;cnt<total;cnt++)
        {
         OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()>=OP_BUY && OrderSymbol()==Symbol() && OrderMagicNumber()==megic)
          {
           if (OrderType()==OP_BUY)
            {
             if(MACD1>0 && MACD2<MACD1 && MACDClosLevel*Point && MA1>MA2*Point)
              {
               OrderClose(OrderTicket(),0.2,Bid,3,0); // 
               return;
              }
            }
          }
        }
      }
     //   Sell
     if (TrailingStop>0)
      {
       OrderSelect(ticket,SELECT_BY_POS,MODE_TRADES);
        {
         if(OrderType()==OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==megic)
          {
           if(Ask-OrderOpenPrice()<Point*TrailingStop)
            {
             if(OrderStopLoss()>Ask-Point*TrailingStop)
              {
               OrderModify(OrderTicket(),OrderOpenPrice(),Ask-Point*TrailingStop,OrderTakeProfit(),0,0);
               return;
              }
            }
          }
         //  Buy
         if(OrderType()==OP_BUY)
          {
           if((OrderOpenPrice()+Bid)<(Point*TrailingStop))
            {
             if((OrderStopLoss()<(Bid-Point*TrailingStop)) || (OrderStopLoss()==0))
              {
               OrderModify(OrderTicket(),OrderOpenPrice(),Bid+Point*TrailingStop,OrderTakeProfit(),0,0);
               return;
              }
            }
          }
        }
      }
    return;
   }
//+------------------------------------------------------------------+

